#include <chrono>
#include <iostream>
#include <ros/ros.h>
#include <stdio.h>
#include <thread>
#include <functional>

#include "sender.h"

// google glog
#include <glog/logging.h>

#include <unistd.h>

using namespace std;
using namespace std::this_thread;

namespace test_pub {

/***************************/
/*     SenderPrivate   */
/***************************/

class SenderPrivate {
public:
  SenderPrivate();
  ~SenderPrivate();
public:
  // pub
  ros::Publisher pub_;
};

SenderPrivate::SenderPrivate() { LOG(INFO) << "in SenderPrivate"; };

SenderPrivate::~SenderPrivate() { LOG(INFO) << "in ~SenderPrivate"; };

/********************/
/*     Sender   */
/********************/

Sender::Sender() { LOG(INFO) << "in Sender()..."; }

Sender::Sender(ros::NodeHandle &nh) {
  LOG(INFO) << "in Sender()...";
  // construct SenderPrivate object
  m_pHandle = make_shared<SenderPrivate>();
  // pub
  m_pHandle->pub_ =
      nh.advertise<std_msgs::String>("/channel", 1000);
}

Sender::~Sender() { LOG(INFO) << "in ~Sender()..."; }

/**********************/
/*     start Sender   */
/**********************/
void Sender::startSender() {
  LOG(INFO) << "in startSender";
  // start Sender
  thread t(&Sender::run, this);
  t.detach();
}

/********************/
/*     Sender run   */
/********************/
void Sender::run() {
  LOG(INFO) << "in Sender::run()";

  // build ros::Rate
  ros::Rate r(25);
  size_t seq = 0;

  while(true) {
    seq ++;
    std_msgs::String str;
    str.data = to_string(seq);
    m_pHandle->pub_.publish(str);
    LOG(INFO) << "sender pub---" << str;
    r.sleep();
  }
}

}